! This program calculates Time-lags (in micro-sec) and mod(del-n-gamaa/del-Tb)
! as function of Energy(in keV) when variation of seed photon is considered.



         implicit none
  
         !------------------------------------------------------------------------
         !--------- declaration of variables, functions etc.----------------------
         !------------------------------------------------------------------------
         
         integer :: i,j,n,cn,counter=1,iref, iter=1
         
         character(len = 100) :: out1, out2, out3, out4, out5, out6

          
         real*8 :: sum1, sum4, sigmat=6.65d-25,k=1.38d-16
         real*8 :: cal2, compr, compj 
         real*8 :: mec2=511.0, pi=3.14159, af, Lf, h= 6.626d-27, cc=3.0d10

         !  cc:velocity of light; af, Lf are actually a and L in eq1 of paper 
           
         real*8 :: enmin,enmax,nwenmin,nwenmax,den,del_te,del_tb
         real*8 :: max, kte, ktb, aa, bb, omgtc, omga, rval
         real*8 :: rdelte = 0., idelte =0., rdeltb=1., ideltb=0., num, rdelte1, idelte1, eps
         real*8 :: beta, tau, Eref
         real*8 :: compr_te, compr_tb, compj_te, compj_tb, freq
         
         real*8,dimension(4000) :: a,b,c,r,u
         real*8,dimension(4000) :: r1,im1     !used in sec2and3
         real*8,dimension(4000) :: r2,im2,a_tbte,c_tbte      !used in sec2and3

         real*8,dimension(0:4000) :: en,nwen,nwdlen
         real*8,dimension(4000) :: ngama, ngama_1, ngama2_2, ngama21 

         complex*16 :: compi,denom,dte,cal1, sum2,sum3
         complex*16 :: delte, delte1, deltb
   
         complex*16,dimension(4000) ::b_tbte,u_tbte   !used in sec2and3
         complex*16,dimension(4000) :: w1 ,r_tbte 


         !-----Reading data from readme file----------------------------------------
         !-------------------------------------------------------------------------

         open(10, file = "input-timelag-seed.txt")
         read(10,*) n, cn, enmin, enmax
	 read(10,*) eps
	 read(10,*) tau, kte, ktb
         read(10,*) af, Lf, freq
  !       read(10,*) iter     ! 0 => no iter; 1 => with iter
         read(10,*) out1, out2

500      continue 
         
      
         !-------------------------------------------------------------------------
         !  SECTION1: calculation ngama and its derivatives ie solving eq2 of paper
         !------------------------------------------------------------------------
         Eref=4.0  
         omga = 2.*pi*freq
         omgtc = (Lf*omga)/(cc*tau)           ! calculated from deails after eq1 (read next 2 lines)
         max= tau + (tau**2)

         delte =cmplx(rdelte, idelte)
         deltb =cmplx(rdeltb, ideltb)
         delte1 =cmplx(rdelte1, idelte1)
         compi=(0,1)

         den = (enmax - enmin)/n
         nwenmin = (10**(enmin)) 
         nwenmax = 10**(enmax)


         do i=0, n-1
            en(i+1)= enmin + i*den
         end do

         do i=1,n
            nwen(i)= 10**en(i)
            if(nwen(i) .le. Eref)iref=i
         end do


         ! obtaining new differentials, we call nwdleni
         do i=1,n-1
            nwdlen(i)= nwen(i+1)- nwen(i)
         end do

         nwdlen(n)= nwdlen(n-1)                           !we put it by hand

         ! calculating constants needed for finding other values

         aa=(6.0*pi*af*af*mec2*omgtc)/(((af+Lf)**3 - (af)**3)*(h**3)*cc*cc*omga)

         bb=(aa*ktb*max)/(2.*kte*max + mec2)

         ! we use following 2 relations 
         ! for further calculation we require nwen(0) and  nwdlen(0) so  we use following
         ! 2 relations  nwen(n+1)/nwen(n) =  nwen(n)/nwen(n-1) and
         ! nwdlen(n+1)/nwen(n+1) =  nwdlen(n)/nwen(n1) giving

         nwen(0) =(nwen(1)*nwen(1))/nwen(2)        
         nwdlen(0) =  (nwen(0)*nwdlen(1))/nwen(1)
 
         ! getting values of a(i) etc. which are required to integrate the equation 2
         ! using tridag of NR

         a(1)= ( kte - nwdlen(1))* nwen(1)*nwen(1)*nwdlen(1)

         b(1)=  (2.*(nwen(1)- kte) -mec2/max)*nwdlen(1)*nwdlen(1)*nwdlen(0) +&
                  ( nwdlen(1)*nwdlen(1)- kte*(nwdlen(1)+nwdlen(0)))*nwen(1)*nwen(1)
 
         c(1)= kte*nwen(1)*nwen(1)*nwdlen(0)

         r(1)=  -(aa*nwen(1)*nwen(1)*nwdlen(1)*nwdlen(1)*nwdlen(0))/(exp(nwen(1)/ktb) -1) -  &
                   ( (kte - nwdlen(1))*nwen(1)*nwen(1)*nwdlen(1))*(bb*nwen(0))
         
         do i=2,n
               a(i)= ( kte - nwdlen(i))* nwen(i)*nwen(i)*nwdlen(i)

               b(i)=  (2.*(nwen(i)- kte) -mec2/max)*nwdlen(i)*nwdlen(i)*nwdlen(i-1) +&
                       ( nwdlen(i)*nwdlen(i)- kte*(nwdlen(i)+nwdlen(i-1)))*nwen(i)*nwen(i)

               c(i)= kte*nwen(i)*nwen(i)*nwdlen(i-1)

               r(i)=  -(aa*nwen(i)*nwen(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/(exp(nwen(i)/ktb) -1) 
               
            end do


            call tridag(a,b,c,r,u,n) 

             ! finding first derivative of function u(i) [i.e. n_gama]
            do i = 1, n-1
                ngama_1(i) = (u(i+1)-u(i))/(nwdlen(i))
             end do
             
            do i = 1, n-2
                ngama2_2(i)=  ((u(i+2)-u(i+1))/(nwdlen(i)*nwdlen(i+1))) -&
                            ((u(i+1)-u(i))/(nwdlen(i)*nwdlen(i)))
             end do

            do i = 1, n-2  ! note we've increased i by 1 on RHS aswe dont have value of u(i-1) when i=1
                 ngama21(i)=  (u(i+2)*nwdlen(i) - u(i+1)*(nwdlen(i+1)+nwdlen(i)) + u(i)*nwdlen(i+1)) /&
                     (nwdlen(i+1)*nwdlen(i+1)*nwdlen(i))
             end do
             
!!$             ! opening file for storing values of ngama and its first and second derivatives
!!$             open(39,file= out1) 
!!$             do i=1,n-2
!!$                write(39, *) nwen(i),u(i),ngama_1(i), ngama21(i)
!!$             end do
!!$             close(39)

             
         !----------------------------------------------------------------------------
         !                   SECTION2 solving equ7 for general case 
         !----------------------------------------------------------------------------

         ! calculating different coeffs when delte and deltb both variy. These are labelled as a_tbe(i)
         ! b_tbe(i) etc. Note b_tbe and output u_tbe are complex other are real

100          continue

             do j=1,n-2
                ngama(j)=u(j)      !beacuse for subroutine 'ctridag' argument is 'u' not 'ngama' 
             end do
 
            
             ! these are values of coeff when we use more correct formula for 2nd derivative
             
             do i=1,n-2
            
                a_tbte(i)= (kte*ngama(i) -(ngama(i) + (2.0*kte*ngama_1(i)))*nwdlen(i) )*nwdlen(i)

                b_tbte(i)= (ngama(i) + 2.0*kte*ngama_1(i))*(nwdlen(i)*nwdlen(i)) - &
                             ngama(i)*kte*(nwdlen(i) + nwdlen(i-1)) - &
                                        (aa*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/((exp(nwen(i)/ktb)-1.0)) + &
                             (compi*omgtc*mec2*ngama(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1))/(nwen(i)*nwen(i)) 
                        
                c_tbte(i)= ngama(i)*kte*nwdlen(i-1)
            
                r_tbte(i)= (kte*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*delte)*((2.0*ngama(i)/(nwen(i)*nwen(i)))-(ngama21(i))) + &
                               (aa*nwen(i)*nwdlen(i)*nwdlen(i)*nwdlen(i-1)*deltb)/ &
                                ((ktb)*(exp(nwen(i)/ktb)-1.0)*(exp(-nwen(i)/ktb) - 1.0)) 
             end do




         call ctridag(a_tbte,b_tbte,c_tbte,r_tbte,u_tbte,cn-2)
 
         open(46, file= out1)
         do i=1,n-2
            write(46,*) nwen(i),abs(u_tbte(i)) !
         end do
         close(46)
       
!!$          
     !*****************************************************************************************
     !-------SECTION3 of PAPER------- -----VARIATION OF SEED PHOTON TEMPERATURE ----------
     !******************************************************************************************    

         if (iter .eq. 0 ) goto 200
    
         sum1=0.
         cal2=0.
         cal1=(0.,0.)
         sum2=(0.,0.)
         sum3=(0.,0.)

         do i=1,n-2
            sum1 = sum1 + ngama(i)*nwen(i)*nwdlen(i)
            sum2 = sum2 + ngama(i)*u_tbte(i)*nwen(i)*nwen(i)*nwdlen(i)
            sum3 = sum3 + ngama(i)*u_tbte(i)*nwen(i)*nwdlen(i)
             
            cal1 = cal1 + ngama(i)*u_tbte(i)*nwdlen(i)
            cal2 = cal2 + ngama(i)*nwdlen(i)
         end do
       
         delte1 = (4.0*sum3 - (sum2)/(kte)) / ( (compi*3.0*omga*mec2)/(2.0*sigmat*cc) - 4.0*sum1)

         compr=(real(delte1)-real(delte))/real(delte1)
         compj=(Imag(delte1)-Imag(delte))/Imag(delte1)
          
         delte=delte1
       
         if(abs(compr) .gt. eps .or. abs(compj) .gt. eps) goto 100


200      continue
       
         !-----------------------------------------------------------------------------
         !                   SECTION4: calculating phase-lag/time-lag between 2 energies     
         !-----------------------------------------------------------------------------

         !   taking product of del-ngama(ref) with conj-del-ngama(i) for te varying
         do i=1,n-2
            w1(i)=conjg(u_tbte(iref))*(u_tbte(i))
            r1(i)=real(w1(i))
            im1(i)=imag(w1(i))
         end do

         !---------- using above information  phase lag is calculated:
         !----- when either of te or tb varies-------------------------------------
         open(51, file= out2)
         do i=1,n-2 
            write(51,*) nwen(i), (atan2(im1(i),r1(i))*1e6/(2.*pi*freq))
         end do
         close(51)

       end program

       !************************************************************************
          SUBROUTINE tridag(a,b,c,r,u,n)
      INTEGER n,NMAX
      REAL*8 a(n),b(n),c(n),r(n),u(n)
      PARAMETER (NMAX=15000)
      INTEGER j
      REAL*8 bet,gam(NMAX)
      if(b(1).eq.0.)STOP 'tridag: rewrite equations'
      bet=b(1)
      u(1)=r(1)/bet
      do 11 j=2,n
        gam(j)=c(j-1)/bet
        bet=b(j)-a(j)*gam(j)
        if(bet.eq.0.)STOP 'tridag failed'
        u(j)=(r(j)-a(j)*u(j-1))/bet
11    continue
      do 12 j=n-1,1,-1
        u(j)=u(j)-gam(j+1)*u(j+1)
12    continue
      return
      END

      !********************************************************************
            SUBROUTINE ctridag(ca,cb,cc,cr,cu,cn)
      INTEGER cn,cNMAX
      REAL*8 ca(cn),cc(cn)
      complex*16 cb(cn),cu(cn),cr(cn)
      PARAMETER (cNMAX=15000)
      INTEGER j
      complex*16 bet,gam(cNMAX)
      if(cb(1).eq.0.)stop 'ctridag: rewrite equations'
      bet=cb(1)
      cu(1)=cr(1)/bet
      do 11 j=2,cn
        gam(j)=cc(j-1)/bet
        bet=cb(j)-ca(j)*gam(j)
        if(bet.eq.0.)stop 'ctridag failed'
        cu(j)=(cr(j)-ca(j)*cu(j-1))/bet
11    continue
      do 12 j=cn-1,1,-1
        cu(j)=cu(j)-gam(j+1)*cu(j+1)
12    continue
      return
      END
